SystemOrganization addCategory: #'FuelPlatform-Pharo-01x'!

FLPharoPlatform subclass: #FLPharo1Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-01x'!

FLPharo1Platform subclass: #FLPharo11Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-01x'!

!FLPharo11Platform class methodsFor: 'private-extensions-flsubstitutioncluster' stamp: 'MaxLeske 2/22/2016 14:44'!
add: anObject substitutedBy: anotherObject traceWith: aAnalysis
	<flExtensionOf: #FLSubstitutionCluster isSource: true>
	^ 'add: anObject substitutedBy: anotherObject traceWith: aAnalysis

		substitutions 
			at: anObject 
			ifAbsent: [ 
				substitutions at: anObject put: anotherObject.
				(substitutes identityIncludes: anObject) ifFalse:  [substitutes add: anotherObject].
				aAnalysis trace: anotherObject ]'! !

!FLPharo11Platform class methodsFor: 'private-extensions-set' stamp: 'MaxLeske 2/22/2016 14:43'!
addIfNotPresent: anObject ifPresentDo: aBlock
	<flExtensionOf: #Set isSource: true>
	^ 'addIfNotPresent: anObject ifPresentDo: aBlock
		"Include anObject as one of the receiver''s elements and then value aBlock, but only if there
		is no such element already. Anwser anObject.

		Sets in Pharo 1.2 and before can''t contain nil, so this implementation is wrong in that version. This is the right one (in Pharo 1.2):"

		| index |
		anObject ifNil: [self error: ''Sets cannot meaningfully contain nil as an element''].
		index := self findElementOrNil: anObject.
		(array at: index) 
			ifNil: [ self atNewIndex: index put: anObject ]
			ifNotNil: [ aBlock value ].
		^ anObject'! !

!FLPharo11Platform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 4/28/2016 17:08'!
addInstVarNamed: aString
	<flExtensionOf: #Class>
	"Add the argument, aString, as one of the receiver's instance variables."
	^((Smalltalk globals at: #ClassBuilder) new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString, ' ', aString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

!FLPharo11Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 15:09'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ :x | ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLPharo11Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/22/2016 11:13'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 (Smalltalk at: #FileDirectory) default deleteFileNamed: aFilename! !

!FLPharo11Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/22/2016 14:50'!
expectedFailures
	<flExtensionOf: #FLBasicSerializationTest>
	^ #(testConsiderCustomWideSymbolGlobal testSetElement testSetWithNil testSetWithSetElement)! !

!FLPharo11Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/22/2016 15:33'!
fixMetacello
	[ Gofer it
	    squeaksource: 'MetacelloRepository';
	    package: 'ConfigurationOfMetacello';
	    load.
	(Smalltalk at: #ConfigurationOfMetacello) load ]
		on: Deprecation do: [ :exception | exception resume ]! !

!FLPharo11Platform class methodsFor: 'private-extensions-flsubstitutioncluster' stamp: 'MaxLeske 2/22/2016 14:44'!
initializeAnalyzing
	<flExtensionOf: #FLSubstitutionCluster isSource: true>
	^ 'initializeAnalyzing

		super initializeAnalyzing.
		substitutions := IdentityDictionary new.
		substitutes := OrderedCollection new'! !

!FLPharo11Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 15:41'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		#('Pharo1.1' 'Pharo-1.1') anySatisfy: [ :version |
			SystemVersion current version beginsWith: version ] ]! !

!FLPharo11Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 11:13'!
methodNamed: aSelector
	<flExtensionOf: #Behavior>
	^ self methodDict at: aSelector! !

!FLPharo11Platform class methodsFor: 'private-extensions-InflateStream' stamp: 'MaxLeske 2/22/2016 11:13'!
next: n into: buffer startingAt: startIndex
	<flExtensionOf: #InflateStream isSource: true>
	^ 'next: n into: buffer startingAt: startIndex
	"Read n objects into the given collection. 
	Return aCollection or a partial copy if less than
	n elements have been read."
	| c numRead count |
	n = 0 ifTrue: [ ^buffer ].
	numRead := 0.
	["Force decompression if necessary"
	(c := self next) == nil 
		ifTrue:[^buffer copyFrom: 1 to: startIndex+numRead-1].
	"Store the first value which provoked decompression"
	buffer at: startIndex + numRead put: c.
	numRead := numRead + 1.
	"After collection has been filled copy as many objects as possible"
	count := (readLimit - position) min: (n - numRead).
	buffer 
		replaceFrom: startIndex + numRead 
		to: startIndex + numRead + count - 1 
		with: collection 
		startingAt: position+1.
	position := position + count.
	numRead := numRead + count.
	numRead = n] whileFalse.
	^buffer'! !

!FLPharo11Platform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/22/2016 14:41'!
reduceRight: aBlock
	<flExtensionOf: #SequenceableCollection>
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := Array new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!FLPharo11Platform class methodsFor: 'private-extensions-flprimitivecluster' stamp: 'MaxLeske 2/22/2016 14:44'!
registerIndexesOn: aDictionary
	<flExtensionOf: #FLPrimitiveCluster isSource: true>
	^ 'registerIndexesOn: aDictionary

		self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLPrimitiveCluster >> #add: anObject traceWith: aAnalysis"
		
		"this is a work around for sets that can not yet contain nil"
		objects := FLLargeIdentitySet new 
			addAll: objects; 
			yourself.
		super registerIndexesOn: aDictionary.'! !

!FLPharo11Platform class methodsFor: 'private-extensions-class' stamp: 'MaxLeske 4/28/2016 17:08'!
removeInstVarNamed: aString
	<flExtensionOf: #Class>
	"Remove the argument, aString, as one of the receiver's instance variables."

	| newInstVarString |
	(self instVarNames includes: aString)
		ifFalse: [self error: aString , ' is not one of my instance variables'].
	newInstVarString := ''.
	(self instVarNames copyWithout: aString) do: 
		[:varName | newInstVarString := newInstVarString , ' ' , varName].
	^((Smalltalk globals at: #ClassBuilder) new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: newInstVarString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!FLPharo11Platform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/22/2016 14:41'!
shuffleBy: aRandom
	<flExtensionOf: #SequenceableCollection>
	"Durstenfeld's version of the Fisher-Yates shuffle"

	self size to: 2 by: -1 do: [ :i | 
		self swap: i with: (aRandom nextInt: i) ]! !

!FLPharo11Platform class methodsFor: 'private-extensions-sequenceablecollection' stamp: 'MaxLeske 2/22/2016 14:42'!
sum: aBlock
	<flExtensionOf: #SequenceableCollection>
	"This is implemented using a variant of the normal inject:into: pattern. 
	The reason for this is that it is not known whether we're in the normal 
	number line, i.e. whether 0 is a good initial value for the sum. 
	Consider a collection of measurement objects, 0 would be the unitless 
	value and would not be appropriate to add with the unit-ed objects."
	| sum sample |
	sample := aBlock value: self anyOne.
	sum := self inject: sample into: [ :previousValue :each |  previousValue + (aBlock value: each) ].
	^ sum - sample! !

!FLPharo11Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MarcusDenker 6/8/2016 15:42'!
tempNamed: aName
	<flExtensionOf: #MethodContext>
	| index |
	index := self tempNames indexOf: aName.
	^ self closure 
		ifNil: [ self tempAt: index ]
		ifNotNil: [ :closure | closure at: index ]! !

!FLPharo11Platform class methodsFor: 'private-extensions-weakobjectstest' stamp: 'MaxLeske 2/22/2016 15:08'!
testAssociationWithWeakFinalizationList
	<flExtensionOf: #FLWeakObjectsTest>! !

FLPharo1Platform subclass: #FLPharo12Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-01x'!

!FLPharo12Platform class methodsFor: 'private-extensions-flsubstitutioncluster' stamp: 'MaxLeske 2/22/2016 13:53'!
add: anObject substitutedBy: anotherObject traceWith: aAnalysis
	<flExtensionOf: #FLSubstitutionCluster isSource: true>
	^ 'add: anObject substitutedBy: anotherObject traceWith: aAnalysis

		substitutions 
			at: anObject 
			ifAbsent: [ 
				substitutions at: anObject put: anotherObject.
				(substitutes identityIncludes: anObject) ifFalse:  [substitutes add: anotherObject].
				aAnalysis trace: anotherObject ]'! !

!FLPharo12Platform class methodsFor: 'private-extensions-set' stamp: 'MaxLeske 2/22/2016 13:56'!
addIfNotPresent: anObject ifPresentDo: aBlock
	<flExtensionOf: #Set isSource: true>
	^ 'addIfNotPresent: anObject ifPresentDo: aBlock
		"Include anObject as one of the receiver''s elements and then value aBlock, but only if there
		is no such element already. Anwser anObject.

		Sets in Pharo 1.2 and before can''t contain nil, so this implementation is wrong in that version. This is the right one (in Pharo 1.2):"

		| index |
		anObject ifNil: [self error: ''Sets cannot meaningfully contain nil as an element''].
		index := self findElementOrNil: anObject.
		(array at: index) 
			ifNil: [ self atNewIndex: index put: anObject ]
			ifNotNil: [ aBlock value ].
		^ anObject'! !

!FLPharo12Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 14:00'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ :x | ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLPharo12Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/22/2016 11:13'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 (Smalltalk at: #FileDirectory) default deleteFileNamed: aFilename! !

!FLPharo12Platform class methodsFor: 'private-extensions-flsubstitutioncluster' stamp: 'MaxLeske 2/22/2016 13:54'!
initializeAnalyzing
	<flExtensionOf: #FLSubstitutionCluster isSource: true>
	^ 'initializeAnalyzing

		super initializeAnalyzing.
		substitutions := IdentityDictionary new.
		substitutes := OrderedCollection new'! !

!FLPharo12Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 11:13'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo1.2' ]! !

!FLPharo12Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 11:13'!
methodNamed: aSelector
	<flExtensionOf: #Behavior>
	^ self methodDict at: aSelector! !

!FLPharo12Platform class methodsFor: 'private-extensions-InflateStream' stamp: 'MaxLeske 2/22/2016 11:13'!
next: n into: buffer startingAt: startIndex
	<flExtensionOf: #InflateStream isSource: true>
	^ 'next: n into: buffer startingAt: startIndex
	"Read n objects into the given collection. 
	Return aCollection or a partial copy if less than
	n elements have been read."
	| c numRead count |
	n = 0 ifTrue: [ ^buffer ].
	numRead := 0.
	["Force decompression if necessary"
	(c := self next) == nil 
		ifTrue:[^buffer copyFrom: 1 to: startIndex+numRead-1].
	"Store the first value which provoked decompression"
	buffer at: startIndex + numRead put: c.
	numRead := numRead + 1.
	"After collection has been filled copy as many objects as possible"
	count := (readLimit - position) min: (n - numRead).
	buffer 
		replaceFrom: startIndex + numRead 
		to: startIndex + numRead + count - 1 
		with: collection 
		startingAt: position+1.
	position := position + count.
	numRead := numRead + count.
	numRead = n] whileFalse.
	^buffer'! !

!FLPharo12Platform class methodsFor: 'private-extensions-flprimitivecluster' stamp: 'MaxLeske 2/22/2016 13:58'!
registerIndexesOn: aDictionary
	<flExtensionOf: #FLPrimitiveCluster isSource: true>
	^ 'registerIndexesOn: aDictionary

		self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLPrimitiveCluster >> #add: anObject traceWith: aAnalysis"
		
		"this is a work around for sets that can not yet contain nil"
		objects := FLLargeIdentitySet new 
			addAll: objects; 
			yourself.
		super registerIndexesOn: aDictionary.'! !

FLPharo1Platform subclass: #FLPharo13Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-01x'!

!FLPharo13Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/22/2016 10:37'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 (Smalltalk at: #FileDirectory) default deleteFileNamed: aFilename! !

!FLPharo13Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 09:32'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo1.3' ]! !

!FLPharo13Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 09:33'!
methodNamed: aSelector
	<flExtensionOf: #Behavior>
	^ self methodDict at: aSelector! !

!FLPharo13Platform class methodsFor: 'private-extensions-InflateStream' stamp: 'MaxLeske 2/22/2016 10:34'!
next: n into: buffer startingAt: startIndex
	<flExtensionOf: #InflateStream isSource: true>
	^ 'next: n into: buffer startingAt: startIndex
	"Read n objects into the given collection. 
	Return aCollection or a partial copy if less than
	n elements have been read."
	| c numRead count |
	n = 0 ifTrue: [ ^buffer ].
	numRead := 0.
	["Force decompression if necessary"
	(c := self next) == nil 
		ifTrue:[^buffer copyFrom: 1 to: startIndex+numRead-1].
	"Store the first value which provoked decompression"
	buffer at: startIndex + numRead put: c.
	numRead := numRead + 1.
	"After collection has been filled copy as many objects as possible"
	count := (readLimit - position) min: (n - numRead).
	buffer 
		replaceFrom: startIndex + numRead 
		to: startIndex + numRead + count - 1 
		with: collection 
		startingAt: position+1.
	position := position + count.
	numRead := numRead + count.
	numRead = n] whileFalse.
	^buffer'! !

FLPharo1Platform subclass: #FLPharo14Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform-Pharo-01x'!

!FLPharo14Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 08:11'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo1.4' ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 08:27'!
abstractBytecodeMessageAt: pc
	<flExtensionOf: #CompiledMethod>
	"Answer the abstract bytecode message at pc in the receiver."
	^[(InstructionStream new method: self pc: pc) interpretNextInstructionFor: nil]
		on: MessageNotUnderstood
		do: [:ex| ex message]! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 08:26'!
abstractBytecodeMessagesDo: aBlock
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver."
	self method
		abstractBytecodeMessagesFrom: startpc
		to: self endPC
		do: aBlock'! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 08:27'!
abstractBytecodeMessagesFrom: startpc to: endpc do: aBlock
	<flExtensionOf: #CompiledMethod>
	"Evaluate aBlock with the sequence of abstract bytecodes from startpc through endpc in the receiver"
	| scanner |
	scanner := InstructionStream new method: self pc: startpc.
	[scanner pc <= endpc] whileTrue:
		[[scanner interpretNextInstructionFor: nil]
			on: MessageNotUnderstood
			do: [:ex| aBlock value: ex message]]! !

!FLPharo1Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 4/30/2016 14:08'!
addClasses
	Object 
		subclass: #Context
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName.
		
	Object 
		subclass: #DebugAction
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName.
		
	Stream subclass: #AbstractBinaryFileStream
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLPharo1Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 09:01'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLPharo1Platform class methodsFor: 'adding' stamp: 'MaxLeske 2/22/2016 00:55'!
addTraits
	(Smalltalk classOrTraitNamed: #TClass) ifNil: [
		Trait
			named: #TClass
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TClassDescription) ifNil: [
		Trait 
			named: #TClassDescription
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TBehavior) ifNil: [
		Trait 
			named: #TBehavior
			uses: {}
			category: self hacksCategoryName ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-symbol' stamp: 'MaxLeske 2/22/2016 00:55'!
asMethodPreamble
	<flExtensionOf: #Symbol>
	self numArgs = 0 ifTrue: [ ^self asString].
	^ String streamContents: [ :str | 
		self keywords doWithIndex: [ :each :index | 
				str
					nextPutAll: each;
					nextPutAll: ' var' , index asString ] ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/22/2016 00:55'!
assertWellMaterializedInto: aMethodContext in: aTestCase
	<flExtensionOf: #MethodContext isSource: true>
	^ 'assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]'! !

!FLPharo1Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/22/2016 00:55'!
basicAddHacks
	super basicAddHacks.
	
	self
		addClasses;
		addTraits! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 08:26'!
blockCreationBytecodeMessage
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'blockCreationBytecodeMessage
	"Answer the abstract bytecode message that created the receiver."
	| blockCreationBytecodeSize |
	^self method abstractBytecodeMessageAt: startpc - (blockCreationBytecodeSize := 4)

	"(SortedCollection sortBlock: [:a :b| a compare: b caseSensitive: false]) sortBlock blockCreationBytecodeMessage"'! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 00:55'!
bytecodesHash
	<flExtensionOf: #CompiledMethod>
	"Answer a 16-bit checksum of the bytecodes."

	^ self crc16from: self initialPC to: self endPC! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 00:55'!
cleanCopyForBlockClosure
	<flExtensionOf: #BlockClosure selector: #cleanCopy>
	"Answer a copy of myself preserving in outerContext just the receiver and method, which are the only needed by a clean block closure."

	^ self shallowCopy
		cleanOuterContext;
		yourself! !

!FLPharo1Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/22/2016 00:55'!
cleanCopyForMethodContext
	<flExtensionOf: #MethodContext selector: #cleanCopy isSource: true>
	^ 'cleanCopy 

	^ self class 
		sender: nil 
		receiver: receiver 
		method: method
		arguments: #()'! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 00:55'!
cleanOuterContext
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'cleanOuterContext
	"Clean my outerContext preserving just the receiver and method, which are the only needed by a clean block closure."

	outerContext := outerContext cleanCopy'! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 00:55'!
codeForNoSource
	<flExtensionOf: #CompiledMethod>
	"this is the marker we use for method that have no source"
	^ String streamContents: [:str |
		str 
			nextPutAll: self selector asMethodPreamble;
			cr;tab;
			nextPutAll: 'self methodHasNoSourceCode' ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-bytearray' stamp: 'MaxLeske 2/22/2016 00:55'!
crc16from: start to: end
	<flExtensionOf: #ByteArray>
	"Compute a 16 bit cyclic redundancy check on the specified interval."

	| crc |
	crc := 0.
	start to: end do: [:i |
		crc := (crc bitShift: -8) bitXor: (
		 #(	16r0000	16rC0C1	16rC181	16r0140	16rC301	16r03C0	16r0280	16rC241
			16rC601	16r06C0	16r0780	16rC741	16r0500	16rC5C1	16rC481	16r0440
			16rCC01	16r0CC0	16r0D80	16rCD41	16r0F00	16rCFC1	16rCE81	16r0E40
			16r0A00	16rCAC1	16rCB81	16r0B40	16rC901	16r09C0	16r0880	16rC841
			16rD801	16r18C0	16r1980	16rD941	16r1B00	16rDBC1	16rDA81	16r1A40
			16r1E00	16rDEC1	16rDF81	16r1F40	16rDD01	16r1DC0	16r1C80	16rDC41
			16r1400	16rD4C1	16rD581	16r1540	16rD701	16r17C0	16r1680	16rD641
			16rD201	16r12C0	16r1380	16rD341	16r1100	16rD1C1	16rD081	16r1040
			16rF001	16r30C0	16r3180	16rF141	16r3300	16rF3C1	16rF281	16r3240
			16r3600	16rF6C1	16rF781	16r3740	16rF501	16r35C0	16r3480	16rF441
			16r3C00	16rFCC1	16rFD81	16r3D40	16rFF01	16r3FC0	16r3E80	16rFE41
			16rFA01	16r3AC0	16r3B80	16rFB41	16r3900	16rF9C1	16rF881	16r3840
			16r2800	16rE8C1	16rE981	16r2940	16rEB01	16r2BC0	16r2A80	16rEA41
			16rEE01	16r2EC0	16r2F80	16rEF41	16r2D00	16rEDC1	16rEC81	16r2C40
			16rE401	16r24C0	16r2580	16rE541	16r2700	16rE7C1	16rE681	16r2640
			16r2200	16rE2C1	16rE381	16r2340	16rE101	16r21C0	16r2080	16rE041
			16rA001	16r60C0	16r6180	16rA141	16r6300	16rA3C1	16rA281	16r6240
			16r6600	16rA6C1	16rA781	16r6740	16rA501	16r65C0	16r6480	16rA441
			16r6C00	16rACC1	16rAD81	16r6D40	16rAF01	16r6FC0	16r6E80	16rAE41
			16rAA01	16r6AC0	16r6B80	16rAB41	16r6900	16rA9C1	16rA881	16r6840
			16r7800	16rB8C1	16rB981	16r7940	16rBB01	16r7BC0	16r7A80	16rBA41
			16rBE01	16r7EC0	16r7F80	16rBF41	16r7D00	16rBDC1	16rBC81	16r7C40
			16rB401	16r74C0	16r7580	16rB541	16r7700	16rB7C1	16rB681	16r7640
			16r7200	16rB2C1	16rB381	16r7340	16rB101	16r71C0	16r7080	16rB041
			16r5000	16r90C1	16r9181	16r5140	16r9301	16r53C0	16r5280	16r9241
			16r9601	16r56C0	16r5780	16r9741	16r5500	16r95C1	16r9481	16r5440
			16r9C01	16r5CC0	16r5D80	16r9D41	16r5F00	16r9FC1	16r9E81	16r5E40
			16r5A00	16r9AC1	16r9B81	16r5B40	16r9901	16r59C0	16r5880	16r9841
			16r8801	16r48C0	16r4980	16r8941	16r4B00	16r8BC1	16r8A81	16r4A40
			16r4E00	16r8EC1	16r8F81	16r4F40	16r8D01	16r4DC0	16r4C80	16r8C41
			16r4400	16r84C1	16r8581	16r4540	16r8701	16r47C0	16r4680	16r8641
			16r8201	16r42C0	16r4380	16r8341	16r4100	16r81C1	16r8081	16r4040)
			 at: ((crc bitXor: (self byteAt: i)) bitAnd: 16rFF) + 1) ].
	^crc! !

!FLPharo1Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/22/2016 00:55'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 aFilename asFileReference delete! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForClassDescription: code
	<flExtensionOf: #ClassDescription selector: #duringTestCompileSilently:>
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForClassDescription: code classified: aCategory
	<flExtensionOf: #ClassDescription selector: #duringTestCompileSilently:classified:>
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForClassDescription: code storeSource: storeSource
	<flExtensionOf: #ClassDescription selector: #duringTestCompileSilently:storeSource:>
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForClassDescription: code storeSource: storeSource classified: aCategory
	<flExtensionOf: #ClassDescription selector: #duringTestCompileSilently:storeSource:classified:>
	^ FLPlatform current 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '''' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForTraitDescription: code
	<flExtensionOf: #TraitDescription selector: #duringTestCompileSilently:>
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForTraitDescription: code classified: aCategory
	<flExtensionOf: #TraitDescription selector: #duringTestCompileSilently:classified:>
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForTraitDescription: code storeSource: storeSource
	<flExtensionOf: #TraitDescription selector: #duringTestCompileSilently:storeSource:>
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
duringTestCompileSilentlyForTraitDescription: code storeSource: storeSource classified: aCategory
	<flExtensionOf: #TraitDescription selector: #duringTestCompileSilently:storeSource:classified:>
	^ FLPlatform current 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '''' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 08:26'!
endPC
	<flExtensionOf: #BlockClosure isSource: true>
	^ 'endPC
	^self blockCreationBytecodeMessage arguments last + startpc - 1'! !

!FLPharo1Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelAcceptForMethodContext: aGeneralMapper
	<flExtensionOf: #MethodContext selector: #fuelAccept:>
	^aGeneralMapper visitMethodContext: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelIgnoredInstanceVariableNames
	<flExtensionOf: #Behavior>
	"Indicates which variables have to be ignored during serialization."

	^#()! !

!FLPharo1Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelInitializeTraitCompositionForBehavior
	<flExtensionOf: #Behavior selector: #fuelInitializeTraitComposition>
	self traitComposition traits do: [:each | each addUser: self]! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitbehavior' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelInitializeTraitCompositionForTraitBehavior
	<flExtensionOf: #TraitBehavior selector: #fuelInitializeTraitComposition>
	self traitComposition traits do: [:each | each addUser: self]! !

!FLPharo1Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelNew
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew! !

!FLPharo1Platform class methodsFor: 'private-extensions-behavior' stamp: 'MaxLeske 2/22/2016 00:55'!
fuelNew: sizeRequested
	<flExtensionOf: #Behavior>
	"Answer an instance of mine in which serialized references will be injected."

	^ self basicNew: sizeRequested! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 4/28/2016 17:03'!
fuelValueWithoutNotifications
	<flExtensionOf: #BlockClosure>
	(Smalltalk globals at: #SystemChangeNotifier) uniqueInstance doSilently: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethodtrailer' stamp: 'MaxLeske 2/22/2016 08:27'!
hasSource
	<flExtensionOf: #CompiledMethodTrailer isSource: true>
	^ 'hasSource
	^ kind == #EmbeddedSourceQCompress or: [ kind == #EmbeddedSourceZip ]'! !

!FLPharo1Platform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/22/2016 00:55'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	<flExtensionOf: #MethodContext isSource: true>
	^ 'initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender'! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
instVarIndexForForClassDescription: instVarName
	<flExtensionOf: #ClassDescription selector: #instVarIndexFor:>
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
		ifTrue: [0]
		ifFalse: [instanceVariables indexOf: instVarName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [superclass instVarIndexFor: instVarName]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
instVarIndexForForTraitDescription: instVarName
	<flExtensionOf: #TraitDescription selector: #instVarIndexFor:>
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
		ifTrue: [0]
		ifFalse: [instanceVariables indexOf: instVarName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [superclass instVarIndexFor: instVarName]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
instanceVariableNamesDoForClassDescription: anUnaryBlock
	<flExtensionOf: #ClassDescription selector: #instanceVariableNamesDo:>
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
instanceVariableNamesDoForTraitDescription: anUnaryBlock
	<flExtensionOf: #TraitDescription selector: #instanceVariableNamesDo:>
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!FLPharo1Platform class methodsFor: 'private-extensions-blockclosure' stamp: 'MaxLeske 2/22/2016 08:26'!
isClean
	<flExtensionOf: #BlockClosure>
	"Answer if the receiver does not close-over any variables other than globals, and does
	 not ^-return (does not close over the home context).  Clean blocks are amenable to
	 being created at compile-time."
	self numCopiedValues > 0 ifTrue:
		[^false].
	self abstractBytecodeMessagesDo:
		[:msg|
		(#(	pushReceiver
			pushReceiverVariable: popIntoReceiverVariable: storeIntoReceiverVariable:
			methodReturnConstant: methodReturnReceiver methodReturnTop)
				includes: msg selector) ifTrue:
					[^false]].
	^true! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 00:55'!
isDoIt
	<flExtensionOf: #CompiledMethod>
	^ self selector isDoIt.! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 00:55'!
isNamedPrimitive
	<flExtensionOf: #CompiledMethod>
	^ self primitive = 117! !

!FLPharo1Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 14:37'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		#('Pharo1' 'Pharo-1') anySatisfy: [ :version |
			SystemVersion current version beginsWith: version ] ]! !

!FLPharo1Platform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/22/2016 08:50'!
julianDayNumberUTC
	<flExtensionOf: #DateAndTime isSource: true>
	^ 'julianDayNumberUTC
	^ jdn'! !

!FLPharo1Platform class methodsFor: 'private-extensions-date' stamp: 'MaxLeske 2/22/2016 09:00'!
materializeFromForDate: aDecoder
	<flExtensionOf: #Date selector: #materializeFrom:>
	<flExtensionClassSide>
	^ self 
		starting: (DateAndTime materializeFrom: aDecoder)
		duration: (Duration days: 1)! !

!FLPharo1Platform class methodsFor: 'private-extensions-contextpart' stamp: 'MaxLeske 2/22/2016 00:55'!
newFromFrameSize: aFrameSize
	<flExtensionOf: #ContextPart>
	<flExtensionClassSide>
	^ super basicNew: aFrameSize! !

!FLPharo1Platform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/22/2016 08:15'!
newName
	<flExtensionOf: #ClassFactoryForTestCase>
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!FLPharo1Platform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 4/28/2016 17:08'!
newSubclassNamed: nameString of: aClass  instanceVariableNames: ivNamesString classVariableNames: classVarsString
	<flExtensionOf: #FLSerializationTest>
	| class |
	(Smalltalk globals at: #SystemChangeNotifier) uniqueInstance doSilently: [
		class := aClass
			subclass: nameString asSymbol
			instanceVariableNames: ivNamesString
			classVariableNames:  classVarsString
			poolDictionaries: ''
			category: self classFactory defaultCategory
	].
	self classFactory createdClasses add: class.
	^ class! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitcomposition' stamp: 'MaxLeske 2/22/2016 00:55'!
remove: aTransformation
	<flExtensionOf: #TraitComposition>
	aTransformation ifNil: [ ^ self ].
	
	self transformations
		remove: aTransformation! !

!FLPharo1Platform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
renameSilentlyForClassDescription: aName
	<flExtensionOf: #ClassDescription selector: #renameSilently:>
	 [ self rename: aName] fuelValueWithoutNotifications! !

!FLPharo1Platform class methodsFor: 'private-extensions-traitdescription' stamp: 'MaxLeske 2/22/2016 00:55'!
renameSilentlyForTraitDescription: aName
	<flExtensionOf: #TraitDescription selector: #renameSilently:>
	 [ self rename: aName] fuelValueWithoutNotifications! !

!FLPharo1Platform class methodsFor: 'private-extensions-date' stamp: 'MaxLeske 2/22/2016 00:55'!
serializeOnForDate: anEncoder
	<flExtensionOf: #Date selector: #serializeOn: isSource: true>
	^ 'serializeOn: anEncoder
	start serializeOn: anEncoder'! !

!FLPharo1Platform class methodsFor: 'private-extensions-dateandtime' stamp: 'MaxLeske 2/22/2016 00:55'!
serializeOnForDateAndTime: anEncoder
	<flExtensionOf: #DateAndTime selector: #serializeOn:>
	anEncoder 
		encodeUint32: self julianDayNumberUTC;
		encodeUint32: self nanoSecond;
		encodeInt24: self secondsSinceMidnight;
		encodeInt24: self offset asSeconds;
		encodeInt32: self offset nanoSeconds.! !

!FLPharo1Platform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/22/2016 08:15'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!FLPharo1Platform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/22/2016 08:15'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLPharo1Platform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/22/2016 08:15'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLPharo1Platform class methodsFor: 'private-extensions-compiledmethod' stamp: 'MaxLeske 2/22/2016 00:55'!
sourceCode
	<flExtensionOf: #CompiledMethod>
	"Retrieve or reconstruct the source code for this method."
	| trailer source |
	trailer := self trailer.
	trailer sourceCode ifNotNil: [:code | ^ code ].
	trailer hasSourcePointer ifFalse: [^ self codeForNoSource].

	"Situation normal;  read the sourceCode from the file"
	source := [self getSourceFromFile]
				on: Error
				do: [ :ex | ex return: nil].
	source isEmptyOrNil ifTrue: [^ self codeForNoSource].			
	^source! !

!FLPharo1Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContext
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithClosureAndSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext2 context2 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self
		resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithNilPc
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithSender
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 context2 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method1.
	context1
		initializeWith: 23
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method1
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context2 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #method2.
	context2
		initializeWith: 18
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #method2
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 5;
				left: 6)
		sender: nil.
	context1 privSender: context2.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 4/30/2016 13:50'!
testContextWithTemp
	"This test should be improved"

	<flExtensionOf: #FLContextSerializationTest>
	| context1 materializedContext1 |
	context1 := (Smalltalk globals at: #MethodContext)
		newForMethod:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp.
	context1
		initializeWith: nil
		stackPtr: 1
		method:
			(Smalltalk globals at: #FLPair) >> #methodWithTemp
		receiver:
			((Smalltalk globals at: #FLPair) new
				right: 4;
				left: 2)
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	materializedContext1 := self
		resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self! !

!FLPharo1Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/22/2016 08:56'!
testDateOffsets
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 1 hour.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLPharo1Platform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/22/2016 08:56'!
testDateOffsetsChanging
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	self serialize:object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour! !

!FLPharo1Platform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/22/2016 08:15'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!FLPharo1Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/30/2016 12:35'!
deleteFileNamed: aFilename
	aFilename asFileReference delete! !

!FLPharo1Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 4/29/2016 09:10'!
fileNamed: aFileame readStreamDo: aBlock
	^ aFileame asFileReference readStreamDo: [ :stream |
		stream binary.
		aBlock value: stream ]! !

!FLPharo1Platform methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 00:55'!
isBigEndian
	^ Smalltalk isBigEndian! !

!FLPharo1Platform methodsFor: 'testing' stamp: 'MaxLeske 2/22/2016 00:55'!
isSpur
	^ false! !

!FLPharo1Platform methodsFor: 'accessing-compiler' stamp: 'MaxLeske 2/22/2016 14:56'!
renamedMethodCopyOf: aMethod selector: aSymbol
	| source |
	source := (aMethod methodClass decompilerClass new
		decompile: aSymbol
		in: aMethod methodClass
		method: aMethod) decompileString.
	"Fix compiler glitch"
	source := source
		copyReplaceAll: 'selector: #=>', String cr
		with: 'selector: #= >', String cr.
	^ (aMethod methodClass compilerClass new
		compile: source
		in: aMethod methodClass
		notifying: nil
		ifFail: []) generate! !
